<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: selectRow,
        }"
        :action-list="[
          {
            text: '质检',
            disabled: selectData.length === 0,
            action: () => start(20),
          },
        ]"
        @get-list="getList"
      >
        <template #fileSlot="{ item }">
          <div
            style="cursor: pointer; color: #409eff"
            @click="handleClickFile(item)"
          >
            {{ item.fileName }}
          </div>
        </template>
      </byTable>
    </div>
    <el-dialog
      title="到货质检"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <el-form
        :model="formData.data"
        :rules="rules"
        ref="formDom"
        label-position="top"
      >
        <div style="margin-bottom: 10px; font-size: 14px">基础信息</div>
        <el-row>
          <el-col :span="8">
            <el-form-item label="供应商" prop="supplyId">
              <el-select
                v-model="formData.data.supplyId"
                placeholder="请选择"
                style="width: 100%"
                disabled
              >
                <el-option
                  v-for="item in supplierData"
                  :label="item.name"
                  :value="item.id"
                >
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="6">
            <el-form-item label="采购单号" prop="code">
              <el-input
                v-model="formData.data.code"
                placeholder="请输入"
                disabled
              >
              </el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <div style="margin-bottom: 10px; font-size: 14px">到货明细</div>
        <el-form-item>
          <el-table :data="formData.data.qualityDetailList">
            <el-table-column
              prop="productType"
              label="货品类型"
              :formatter="(row) => (row.productType == 1 ? '产品' : '物料')"
            />
            <el-table-column prop="productCode" label="货品编码" />
            <el-table-column prop="productName" label="货品名称" />
            <el-table-column prop="productSpec" label="规格型号" />
            <el-table-column prop="productUnit" label="单位" />
            <el-table-column prop="count" label="到货数量" />
            <el-table-column prop="sumQualityCount" label="已质检" />
            <el-table-column
              prop="qualifiedCount"
              label="质检合格"
              min-width="150"
            >
              <template #default="{ row, $index }">
                <el-form-item
                  :prop="'qualityDetailList.' + $index + '.qualifiedCount'"
                  :rules="rules.qualifiedCount"
                  :inline-message="true"
                >
                  <el-input-number
                    v-model="row.qualifiedCount"
                    :precision="4"
                    :controls="false"
                    :min="0"
                  />
                </el-form-item>
              </template>
            </el-table-column>
            <el-table-column
              prop="noQualifiedCount"
              label="质检不合格"
              min-width="150"
            >
              <template #default="{ row, $index }">
                <el-form-item
                  :prop="'qualityDetailList.' + $index + '.noQualifiedCount'"
                  :rules="rules.noQualifiedCount"
                  :inline-message="true"
                >
                  <el-input-number
                    v-model="row.noQualifiedCount"
                    :precision="4"
                    :controls="false"
                    :min="0"
                  />
                </el-form-item>
              </template>
            </el-table-column>
          </el-table>
        </el-form-item>
      </el-form>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm()"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import FileUpload from "@/components/FileUpload/index";
import { computed, defineComponent, ref, watch } from "vue";
import { getToken } from "@/utils/auth";

const uploadFileUrl = ref(import.meta.env.VITE_APP_BASE_API + "/common/upload"); // 上传文件服务器地址
const headers = ref({ Authorization: "Bearer " + getToken() });
const uploadData = ref({});
const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let modalType = ref("add");
let fileList = ref([]);
let rules = ref({
  name: [{ required: true, message: "请输入供应商名称", trigger: "blur" }],
  qualifiedCount: [
    { required: true, message: "请输入质检合格数量", trigger: "blur" },
  ],
  noQualifiedCount: [
    { required: true, message: "请输入质检不合格数量", trigger: "blur" },
  ],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([
  {
    label: "质检状态",
    prop: "status",
    data: [
      {
        label: "未质检",
        value: "0",
      },
      {
        label: "部分质检",
        value: "10",
      },
      {
        label: "已质检",
        value: "20",
      },
    ],
  },
]);
const config = computed(() => {
  return [
    {
      type: "selection",
      attrs: {
        checkAtt: "isCheck",
      },
    },
    {
      attrs: {
        label: "到货单号",
        prop: "code",
      },
    },
    {
      attrs: {
        label: "供应商",
        prop: "supplyName",
      },
    },
    {
      attrs: {
        label: "物品类型",
        prop: "productType",
      },
      render(type) {
        return type == 1 ? "产品" : type == 2 ? "物料" : "";
      },
    },

    {
      attrs: {
        label: "物品编码",
        prop: "productCode",
      },
    },
    {
      attrs: {
        label: "物品名称",
        prop: "productName",
      },
    },
    {
      attrs: {
        label: "规格型号",
        prop: "productSpec",
      },
    },
    {
      attrs: {
        label: "单位",
        prop: "productUnit",
      },
    },
    {
      attrs: {
        label: "到货数量",
        prop: "count",
      },
    },
    {
      attrs: {
        label: "质检合格",
        prop: "qualifiedCount",
      },
    },
    {
      attrs: {
        label: "质检不合格",
        prop: "noQualifiedCount",
      },
    },
    {
      attrs: {
        label: "质检状态",
        prop: "status",
      },
      render(type) {
        return type == 0
          ? "未质检"
          : type == 10
          ? "部分质检"
          : type == 20
          ? "已质检"
          : "";
      },
    },
    {
      attrs: {
        label: "操作",
        width: "100",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "质检",
              type: "primary",
              text: true,
              disabled: row.status == 20,
            },
            el: "button",
            click() {
              selectDataOne.value = [row];
              start(10);
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const formConfig = computed(() => {});
const formDom = ref(null);

const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/arrivalDetail/page", sourceList.value.pagination)
    .then((message) => {
      message.rows.forEach((x) => {
        if (x.status < 20) {
          x.isCheck = true;
        } else {
          x.isCheck = false;
        }
      });
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};

const submitForm = () => {
  formDom.value.validate((valid) => {
    const list = formData.data.qualityDetailList;
    for (let i = 0; i < list.length; i++) {
      const e = list[i];
      delete e.id;
      if (!(e.qualifiedCount + e.noQualifiedCount > 0)) {
        return ElMessage({
          message: "质检数量不能为0！",
          type: "info",
        });
      }
      if (
        e.qualifiedCount + e.noQualifiedCount + Number(e.sumQualityCount) >
        Number(e.count)
      ) {
        return ElMessage({
          message: "质检数量不能大于到货数量！",
          type: "info",
        });
      }
    }
    submitLoading.value = true;
    proxy.post("/quality/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: "质检成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => {
        submitLoading.value = false;
      }
    );
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  dialogVisible.value = true;

  // proxy.post("/productionProcesses/detail", { id: row.id }).then((res) => {
  //   fileList.value = [
  //     {
  //       id: "",
  //       fileName: res.fileName,
  //       path: "",
  //     },
  //   ];
  //   formData.data = res;
  //   dialogVisible.value = true;
  // });
};

getList();
const selectData = ref([]);
const selectDataOne = ref([]);

const selectRow = (data) => {
  selectData.value = data;
};

const start = (type) => {
  modalType.value = "add";
  let ids = [];
  let row = {};
  if (type === 10) {
    row = selectDataOne.value[0];
    ids = selectDataOne.value.map((x) => x.id);
  } else if (type === 20) {
    ids = selectData.value.map((x) => x.id);
    row = selectData.value[0];
  }
  proxy.post("/arrivalDetail/detail", { ids }).then((res) => {
    formData.data = {
      arrivalId: row.arrivalId,
      supplyId: row.supplyId,
      supplyName: row.supplyName,
      code: row.code,
      qualityDetailList: res.map((x) => ({
        ...x,
        arrivalDetailId: x.id,
        qualifiedCount: 0,
        noQualifiedCount: 0,
      })),
    };
    dialogVisible.value = true;
  });
};

watch(selectData, (newVal, oldVal) => {
  if (newVal.length == 0) {
    sourceList.value.data.forEach((x) => {
      if (x.status < 20) {
        x.isCheck = true;
      } else {
        x.isCheck = false;
      }
    });
  } else if (newVal.length == 1) {
    const current = newVal[0];
    sourceList.value.data.forEach((x) => {
      if (x.arrivalId !== current.arrivalId || x.status == 20) {
        x.isCheck = false;
      }
    });
  }
});

onMounted(() => {});
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
:deep(.el-table__header-wrapper .el-checkbox) {
  display: none;
}
</style>